bool checkBtn(int btn, bool sBtn) {
  int btnLed = btn + 6;
  
  digitalWrite(btnLed, HIGH);
  if (sBtn)
    digitalWrite(validateLed, HIGH);
  while (run) {
    if (digitalRead(btn) == LOW) {
      digitalWrite(btnLed, LOW);
      return true;
    } else if (digitalRead(validateBtn) == LOW) {
      digitalWrite(validateLed, LOW);
      digitalWrite(btnLed, LOW);
      return false;
    }
    delay(100);
  }
}

bool restartCurrentTest() {
  bool testAgain = false;
  
  delay(400);
  lcdDisplay(repeatTestMsg, noRsp);
  digitalWrite(validateLed, HIGH);
  digitalWrite(minusLed, HIGH);
  while (run) {
    lcd.setCursor(0, 1);
    if (digitalRead(minusBtn) == LOW) {
      lcd.print(yesRsp);
      digitalWrite(minusLed, LOW);
      digitalWrite(plusLed, HIGH);
      testAgain = true;
    }
    else if (digitalRead(plusBtn) == LOW) {
      lcd.print(noRsp);
      digitalWrite(plusLed, LOW);
      digitalWrite(minusLed, HIGH);
      testAgain = false;
    }
    else if (digitalRead(validateBtn) == LOW) {
      digitalWrite(minusLed, LOW);
      digitalWrite(plusLed, LOW);
      digitalWrite(validateLed, LOW);
      return testAgain;
    }
    delay(150);
  }
}

float displayFinalCCFSScore(int age) {
  float score = 0;
  float ln10 = 2.302585092994046;

  if (age < 20)
    score = (1000*log(7.0+0.1*((resultatHoles/1000)-(12.62-0.08*age))+0.4*((resultatClickTest/1000)-(18.89-1.14*age+0.03*age*age)))/ln10)/1000.0;
  else
    score = (1000*log(7.0+0.1*((resultatHoles/1000)-13.4+0.16*age-0.002*age*age)+0.4*((resultatClickTest/1000)-8.0-0.05*age))/ln10)/1000.0;
  lcdDisplay("CCFS score :", NULL);
  digitalWrite(validateLed, HIGH);
  lcd.setCursor(0, 1);
  lcd.print(score, 3);
  delay(500);
  checkBtn(validateBtn, false);
  return (score);
}

void endOfExam(int age) {
  float score = 0;
  
  lcdDisplay(endOfExamMsg, endOfExamMsg2);
  delay(2000);
  if (clickTestGTime)
    score = displayFinalCCFSScore(age);
  else {
    lcdDisplay("click test < 10", "CCFS unavailable");
    delay(400);
    checkBtn(validateBtn, false);
  }
  saveSession(age, score);
  return;
}

bool saveSession(int age, float score) {
  File recordFile = SD.open(filename, FILE_WRITE);

  lcdDisplay(savingExamMsg, NULL);
  recordFile.println(headerFile);
  recordFile.print(filename);
  recordFile.print(";");
  recordFile.print(age);
  recordFile.print(";");
  recordFile.print(score, 3);
  recordFile.print(";");
  for (int i = 0; i < 9; i++) {
    recordFile.print(Mux1_Order[i]);
    recordFile.print(";");
  }
  for (int i = 0; i < 8; i++) {
    recordFile.print(holesTabTimes[i]);
    recordFile.print(";");
  }
  for (int i = 0; i < 19; i++) {
    recordFile.print(clickTabTimes[i]);
    recordFile.print(";");
  }
  recordFile.print(resultatHoles);
  recordFile.print(";");
  recordFile.print(resultatClickTest);
  recordFile.close();
  lcdDisplay(examSavedMsg, examSavedMsg2);
  delay(3000);
}




bool updateMux1 () {
  int res;
  for(int i = 0 ; i < 9 ; i++){
  if((Mux1_State[i] == 0) && (!(digitalRead(pinPhotoInt[i])))){
    Mux1_State[i] = 1;
    Mux1_Order[holesCounter] = 1;
    return true;
  }
  }
  return false;
}

void cleanVariable() {
  holesCounter = 0;
  for (int i = 0; i < 9; i++) {
    Mux1_State[i] = 0;
    Mux1_Order[i] = 0;
  }
  for (int i = 0; i < 8; i++)
    holesTabTimes[i] = 0;
}

